--[[
SpellAlertSCT
Author:        Eugorym based on code from Awen

Version: 	11000-5.2

Description :
This is a modified version of SpellAlert that instead of putting the notification up in it's own frame will send a message to ScrollingCombatText.

There are several command line options to set how the text is displayed.

/sasct crit [on/off] -- Whether or not the message should be a crit; does nothing if style is set to Message.  [Default is On]
/sasct status -- Displays the current configuration options.
/sasct style [message/vertical/rainbow/horizontal/angled down] -- Animation Style to use.    [Default is Message]
/sasct targetonly [on/off] -- Whether or not to display messages from the selected target only.  [Default is Off]
/sasct test -- Send a test message to see how it looks.  (Also done automatically after a settings change)
/sasct red [0.0 - 1.0] -- Set the red color component of the message.  [Default is 1.0]
/sasct green [0.0 - 1.0] -- Set the green color component of the message.  [Default is 1.0]
/sasct blue [0.0 - 1.0] -- Set the blue color component of the message.  [Default is 1.0]
/sasct emotes [on/off] -- Whether or not to display emotes along with spells.  [Default is On]

Changes :
11000-5.2:
Back to one slash command

11000-5.1:
Fixed a bug with the /sasct reset from version 11000-5

11000-5:
Added the default settings to the help
Added a reset configuration command /sasct reset
Added emote toggle

11000-4:
Message Color is now changeable
Added TargetOnly option

11000-3:
Cleaned up code some more.
Added /sasct command and options for display.
Made file a .zip per request.

11000-2:
Cleaned up code a bit.

11000-1:
Initial Release
	
]]

sasct_color =  {r = 1.0, g = 1.00, b = 1.00};
-- 변수 설정(이하 사냥꾼 관련 코드는 eerien님 코드)
sasct_retarget_on = 1;
sasct_warning_on = 1;
-- 치유 주문, 군중 제어, 디스펠 가능, 데미지 스킬 
--[[sasct_heals = 1;
sasct_cc = 1;
sasct_dispelable = 1;
sasct_damage = 1;]]

-- Local variables
local playerName = nil;
local sa_targetName = nil;
local sa_targetClass = nil;
local sa_targetHostile = nil;
local sa_color_prev = {};
local sa_gains = {};

-- 사냥꾼의 죽은척하기 재타겟을 위한 설정(coded by eerien) "사냥꾼" = "Hunter", "죽은척하기" = "Feign Death"
function SpellAlertSCT_OnUpdate()
	local targetName = UnitName("target");
	if (targetName) then
		sa_targetClass = UnitClass("target");
		sa_targetHostile = UnitIsEnemy("player", "target");
	else
		if (sasct_retarget_on == 1 and sa_targetName and (sa_targetClass == "사냥꾼") and sa_targetHostile ) then
			TargetLastTarget();
			if( UnitHealth("target") == 0 and UnitCanAttack("player", "target") ) then
				ClearTarget();
				SpellAlertSCT_retarget("죽은척하기");
			else
				ClearTarget();
			end
		end
	end
	sa_targetName = targetName;
end

function SpellAlertSCT_OnLoad()
	if ( not SCT_OnLoad ) then
		-- SCT가 없을 때 나오는 메시지
		SpellAlertSCT_print("SpellAlert SCT를 불러오지 못했습니다!  필수 구성 요소인 SCT가 설치되어 있지 않습니다!");
		return;
	end

	this:RegisterEvent("VARIABLES_LOADED");
	
	SlashCmdList["SpellAlertSCTCOMMAND"] = SpellAlertSCT_SlashHandler;
	SLASH_SpellAlertSCTCOMMAND1 = "/sasct";
	SLASH_SpellAlertSCTCOMMAND2 = "/ss"; -- simple command
end

function SpellAlertSCT_OnEvent()
	local mob, spell;
	if ( event == "VARIABLES_LOADED" ) then
		this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS");
		this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF");
		this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF");
		this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
		-- 주기적인 피해 이벤트 추가
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE");
		--
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS");
		this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER");
		
		if ( not SpellAlertSCTDB ) then
			SpellAlertSCTDB = {};
			-- SpellAlert SCT를 처음 불러왔을 때 나오는 메시지
			SpellAlertSCT_print("SpellAlert SCT를 처음으로 사용하셨습니다!")
		end
		
		-- 한글 어법에 맞게 수정
		playerName = GetCVar("realmName").." 서버의 "..UnitName("player");
		
		if ( not SpellAlertSCTDB[playerName] ) then
			SpellAlertSCT_ResetOptions();
			-- 한글 어법에 맞게 수정(첫 프로필을 만들때 만)
			SpellAlertSCT_print(playerName.."님의 프로필이 생성되었습니다");
		else
			if ( SpellAlertSCTDB[playerName].Style == nil ) then SpellAlertSCTDB[playerName].Style = "message"; end
			if ( SpellAlertSCTDB[playerName].Crit == nil ) then SpellAlertSCTDB[playerName].Crit = true; end
			if ( SpellAlertSCTDB[playerName].TargetOnly == nil ) then SpellAlertSCTDB[playerName].TargetOnly = false; end
			if ( SpellAlertSCTDB[playerName].red == nil ) then SpellAlertSCTDB[playerName].red = 1.0; end
			if ( SpellAlertSCTDB[playerName].green == nil ) then SpellAlertSCTDB[playerName].green = 1.0; end
			if ( SpellAlertSCTDB[playerName].blue == nil ) then SpellAlertSCTDB[playerName].blue = 1.0; end
			if ( SpellAlertSCTDB[playerName].Emotes == nil ) then SpellAlertSCTDB[playerName].Emotes = true; end
			-- 한글 어법에 맞게 수정(접속 또는 UI 리로드 할 때)
		--	SpellAlertSCT_print(playerName.."님의 프로필을 불러왔습니다.");
		end
		
		if ( not SpellAlertSCTDB.Crit ) then
			SpellAlertSCTDB.Crit = sasct_default_crit;
		end
		if ( not SpellAlertSCTDB.Style ) then
			SpellAlertSCTDB.Style = sasct_default_style;
		end		
		
		sasct_color.r = tonumber(SpellAlertSCTDB[playerName].red);
		sasct_color.g = tonumber(SpellAlertSCTDB[playerName].green);
		sasct_color.b = tonumber(SpellAlertSCTDB[playerName].blue);
		
		-- 한글 어법에 맞게 수정
	--	SpellAlertSCT_print("도움말을 보실려면 '/sasct' 또는 '/ss' 를 입력하세요.");
	
	elseif (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE") then
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_BEGIN_CAST) do
			if (not SpellAlertSCT_isParty(mob)) then
				SpellAlertSCT_alert(mob, spell, arg1);
			end
			return;
		end
		-- "(.+) begins to perform (.+)."라는 전투 메시지 처리
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_BEGIN_PERFORM) do
			if (not SpellAlertSCT_isParty(mob)) then
				SpellAlertSCT_alert(mob, spell, arg1);
			end
			return;
		end
	elseif (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF") then
		for mob, spell, k in string.gfind(arg1, SA_PTN_SPELL_GAINS_X) do
			return;
		end
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_BEGIN_CAST) do
			if (not SpellAlertSCT_isParty(mob)) then
				SpellAlertSCT_alert(mob, spell, arg1);
			end
			return;
		end
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_TOTEM) do
			if (not SpellAlertSCT_isParty(mob)) then
				SpellAlertSCT_alert(mob, spell, arg1);
			end
			return;
		end
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_GAINS) do
			SpellAlertSCT_alert(mob, spell, arg1);
			return;
		end
	elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_BEGIN_CAST) do
			SpellAlertSCT_alert(mob, spell, arg1);
			return;
		end
	elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then
		for mob, spell, k in string.gfind(arg1, SA_PTN_SPELL_GAINS_X) do
			return;
		end
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_GAINS) do
			SpellAlertSCT_alert(mob, spell, arg1);
			return;
		end
	elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE") then
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_BEGIN_CAST) do
			SpellAlertSCT_alert(mob, spell, arg1);
			return;
		end
		-- "(.+) begins to perform (.+)."라는 전투 메시지 처리
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_BEGIN_PERFORM) do
			SpellAlertSCT_alert(mob, spell, arg1);
			return;
		end
	elseif (event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS") then
		for mob, spell, temp in string.gfind(arg1, SA_PTN_SPELL_GAINS_X) do
			return;
		end
		for mob, spell in string.gfind(arg1, SA_PTN_SPELL_GAINS) do
			if ( (spell == SA_WOTF) or
			     (spell == SA_BERSERKER_RAGE) ) then
				sa_gains[mob] = {};
				sa_gains[mob].spell = spell;
				sa_gains[mob].time = GetTime();
			end
			SpellAlertSCT_alert(mob, spell, arg1);
			return;
		end
	elseif (event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") then
		for spell, mob in string.gfind(arg1, SA_PTN_SPELL_FADE) do
			if ( (spell == SA_WOTF) or
			     (spell == SA_BERSERKER_RAGE) ) then
				local tt = sa_gains[mob];
				if (tt) then
					if (tt.spell == spell) then
						if (GetTime() - tt.time <= 30) then
							SpellAlertSCT_alert(mob, spell, arg1);
						end
					end
					tt[mob] = nil;
					return;
				end
			end
		end
	-- You are afflicted by Living Bomb.
	elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
		if (arg1 == SA_AFFLICT_LIVINGBOMB) then
			SpellAlertSCT_warn(arg1);
		end
	elseif (event == "CHAT_MSG_EMOTE") then
		if (arg1) then
			if (SpellAlertSCTDB[playerName].Emotes) then
				SpellAlertSCT_alert("", "", arg1);
			end
		end
	elseif (event == "CHAT_MSG_MONSTER_EMOTE") then
		local name = arg2;
		if (not name) then
			name = "nil";
		end
		if (arg1) then
			-- takes in a deep breath...   "오닉시아" = "Onyxia"
			if ( (name == "오닉시아") and (arg1 == SA_EMOTE_DEEPBREATH) ) then
				SpellAlertSCT_warn(name .. "|1이;가; " .. arg1);
			end
			if (SpellAlertSCTDB[playerName].Emotes) then
				SpellAlertSCT_alert(name, arg1, name .. "|1이;가; " .. arg1);
			end
		end
	end
end

function SpellAlertSCT_alert(mob, spell, msg)
	-- 한글로된 지역화 화일을 읽어온다
	if (GetLocale()=="koKR") then
		if (SA_SPELLS_IGNORE[spell]) then
			return;
		end
		--[[ 세부적인 옵션
		if (sasct_heals == 0) then
			if (SA_SPELLS_HEALS[spell] == 1) then
				return;
			end
		end
		
		if (sasct_cc == 0) then
			if (SA_SPELLS_CC[spell] == 1) then
				return;
			end
		end
		
		if (sasct_dispelable == 0) then
			if (SA_SPELLS_DISPELABLE[spell] == 1) then
				return;
			end
		end
		
		if (sasct_damage == 0) then
			if (SA_SPELLS_DAMAGE[spell] == 1) then
				return;
			end
		end]]
	end
	
	local targetname = UnitName("target");
	if (mob == targetname) then
		-- 메시지에서 ***를 삭제하여 간략화 한다
		SpellAlertSCT_SCTDisplay(strsub(msg, 0, strlen(msg) - 1));
	else
		if (not SpellAlertSCTDB[playerName].TargetOnly) then
			SpellAlertSCT_SCTDisplay(strsub(msg, 0, strlen(msg) - 1));
		end
	end
end

function SpellAlertSCT_SCTDisplay(msg)
	if (SpellAlertSCTDB[playerName].Style == "message") then
		SCT_Display_Message(msg, sasct_color);
	elseif (SpellAlertSCTDB[playerName].Style == "vertical") then
		SCT_Display(msg, sasct_color, SpellAlertSCTDB[playerName].Crit, "event", 1 )
	elseif (SpellAlertSCTDB[playerName].Style == "rainbow") then
		SCT_Display(msg, sasct_color, SpellAlertSCTDB[playerName].Crit, "event", 2 )
	elseif (SpellAlertSCTDB[playerName].Style == "horizontal") then
		SCT_Display(msg, sasct_color, SpellAlertSCTDB[playerName].Crit, "event", 3 )
	elseif (SpellAlertSCTDB[playerName].Style == "angled down") then
		SCT_Display(msg, sasct_color, SpellAlertSCTDB[playerName].Crit, "event", 4 )
	else
		SCT_Display_Message(msg, sasct_color);
		-- 4가지 SCT 움직임 형태를 선택하지 않았을 때 나오는 메시지
		SpellAlertSCT_print("현재 설정에 오류가 있습니다, 움직임 형태를 찾지 못했습니다.");
	end
end

function SpellAlertSCT_print(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("SpellAlertSCT: "..msg);
	end
end

-- 큰 경고 메시지(Big Warning Message)
function SpellAlertSCT_warn(msg)
	if (sasct_warning_on == 1) then
		WarningFrame:AddMessage(msg, sasct_color.r, sasct_color.g, sasct_color.b, 1, 5);
	end
end

function SpellAlertSCT_isParty(name)
	for i = 1, 4, 1 do
		local partyname = UnitName("party" .. i);
		if (name == partyname) then
			return 1;
		end
	end
	return nil;
end

-- 사냥꾼의 죽은척하기 메시지를 처리 곳(Feign Death Message)
function SpellAlertSCT_retarget(spell)
	if (sasct_retarget_on == 0) then
		return;
	end
	if (not UnitName("target")) then
		if (sa_targetName) then
			if (sa_targetHostile) then
				SpellAlertSCT_print("적의 " .. spell .. "|1으로;로; 인한 혼란 후 타겟 재설정 : " .. sa_targetName);
				TargetLastEnemy();
			else
				SpellAlertSCT_print("적의 " .. spell .. "|1으로;로; 인한 혼란 후 타겟 재설정 : " .. sa_targetName);
				TargetByName(sa_targetName);
			end
		end
	end
end

-- 명령어를 입력했을 때 나오는 메시지 한글화(Korean Locallize)
function SpellAlertSCT_ShowStatus()
	if ( SpellAlertSCTDB[playerName].Crit ) then
		SpellAlertSCT_print(SpellAlertSCTDB[playerName].Style.." 움직임 형태를 사용하여 치명타 메시지로써 표시합니다.");
	else
		SpellAlertSCT_print(SpellAlertSCTDB[playerName].Style.." 움직임 형태를 사용하여 치명타 메시지로써 표시하지 않습니다.");
	end
	if ( SpellAlertSCTDB[playerName].TargetOnly ) then
		SpellAlertSCT_print("선택한 대상의 주문만 경고합니다.");
	else
		SpellAlertSCT_print("모든 대상의 주문을 경고합니다.");
	end
	if ( SpellAlertSCTDB[playerName].Emotes ) then
		SpellAlertSCT_print("감정 표현 경고 : 켜기");
	else
		SpellAlertSCT_print("감정 표현 경고 : 끄기");
	end
	SpellAlertSCT_print("r/g/b 색상 사용 : "..SpellAlertSCTDB[playerName].red.."/"..SpellAlertSCTDB[playerName].green.."/"..SpellAlertSCTDB[playerName].blue..".");
end

-- 사용법 한글화
function SpellAlertSCT_ShowUsage()
	SpellAlertSCT_print("-- 사용법/도움말:");
	SpellAlertSCT_print("/sasct crit [on/off] -- 치명타 메시지로로써 표시할지의 여부를 결정합니다.; 만약에 움직임 형태를 설정하지 않는다면 표시되지 않습니다.  [기본값 : off]");
	SpellAlertSCT_print("/sasct status -- 현재 설정 상태를 표시합니다.");
	SpellAlertSCT_print("/sasct style [message/vertical/rainbow/horizontal/angled down] -- 사용할 움직임 형태.  [기본값 : message]");
	SpellAlertSCT_print("/sasct targetonly [on/off] -- 선택한 대상의 주문만 경고할지의 여부를 결정합니다.  [기본값 : off]");
	SpellAlertSCT_print("/sasct test -- 화면에 어떻게 보이는 지 보기 위해서 테스트 메시지를 보냅니다.  (또한 설정 변경 후 자동적으로 적용됩니다)");
	SpellAlertSCT_print("/sasct red [0.0 - 1.0] -- 메시지의 색상중 빨간색을 설정합니다.  [기본값 : 1.0]");
	SpellAlertSCT_print("/sasct green [0.0 - 1.0] -- 메시지의 색상중 녹색을 설정합니다.  [기본값 : 1.0]");
	SpellAlertSCT_print("/sasct blue [0.0 - 1.0] -- 메시지의 색상중 파란색을 설정합니다.  [기본값 : 1.0]");
end

function SpellAlertSCT_NextParameter(msg)

	local params = nil;
	local command = nil;
	local index = strfind(msg, " ");
	
	if ( index ) then
		command = strsub(msg, 1, index - 1);
		params = strsub(msg, index + 1);
	else
		command = msg;
	end
	
	return command, params;
	
end

function SpellAlertSCT_ResetOptions()
	SpellAlertSCTDB[playerName] = {
			["Crit"] = true,
			["Style"] = "message",
			["TargetOnly"] = false,
			["red"] = 1.0,
			["green"] = 1.0,
			["blue"] = 1.0,
			["Emotes"] = true,
		};
		
	sasct_color.r = 1.0;
	sasct_color.g = 1.0;
	sasct_color.b = 1.0;
end

--  명령어를 입력하여 값을 변경할 때 나오는 메시지 한글화
function SpellAlertSCT_SlashHandler(msg)
	if ( not msg or strlen(msg) <= 0 ) then
		SpellAlertSCT_ShowUsage();
		return;
	end
	
	local command, params = SpellAlertSCT_NextParameter(string.lower(msg));

	if ( command == "crit" ) then
		if ( not params ) then
			if (SpellAlertSCTDB[playerName].Crit == true) then
				SpellAlertSCTDB[playerName].Crit = false;
				SpellAlertSCT_print("치명타 메시지로써 표시 - 끄기.");
			else
				SpellAlertSCTDB[playerName].Crit = true;
				SpellAlertSCT_print("치명타 메시지로써 표시 - 켜기.");
			end
		else
			if (params == "on") then
				SpellAlertSCTDB[playerName].Crit = true;
				SpellAlertSCT_print("치명타 메시지로써 표시 - 켜기.");
			else
				SpellAlertSCTDB[playerName].Crit = false;
				SpellAlertSCT_print("치명타 메시지로써 표시 - 끄기.");
			end
		end
		SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
	elseif ( command == "style" ) then
		if ( not params ) then
			SpellAlertSCT_print("사용할 움직임 형태를 정해야 합니다."); --You must specify a style type to use ().
		else
			if (params == "message") then
				SpellAlertSCTDB[playerName].Style = "message";
				SpellAlertSCT_print("SCT 메시지로써 표시.");
			elseif (params == "vertical") then
				SpellAlertSCTDB[playerName].Style = "vertical";
				SpellAlertSCT_print("세로 움직임 형태 표시(보통).");
			elseif (params == "rainbow") then
				SpellAlertSCTDB[playerName].Style = "rainbow";
				SpellAlertSCT_print("무지개 움직임 형태 표시.");
			elseif (params == "horizontal") then
				SpellAlertSCTDB[playerName].Style = "horizontal";
				SpellAlertSCT_print("가로 움직임 형태 표시.");
			elseif (params == "angled down") then
				SpellAlertSCTDB[playerName].Style = "angled down";
				SpellAlertSCT_print("모난 움직임 형태 표시.");
			else
				SpellAlertSCT_print("움직임 형태를 위해서는 [message/vertical/rainbow/horizontal/angled down]중에서만 선택해야 합니다.");
			end
			SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
		end
	elseif ( command == "targetonly" ) then
		if ( not params ) then
			if (SpellAlertSCTDB[playerName].TargetOnly == true) then
				SpellAlertSCTDB[playerName].TargetOnly = false;
				SpellAlertSCT_print("모든 대상의 주문을 경고합니다.");
			else
				SpellAlertSCTDB[playerName].TargetOnly = true;
				SpellAlertSCT_print("선택한 대상의 주문만 경고합니다.");
			end
		else
			if (params == "on") then
				SpellAlertSCTDB[playerName].TargetOnly = true;
				SpellAlertSCT_print("선택한 대상의 주문만 경고합니다.");
			else
				SpellAlertSCTDB[playerName].TargetOnly = false;
				SpellAlertSCT_print("모든 대상의 주문을 경고합니다.");
			end
		end
	elseif ( command == "emotes" ) then
		if ( not params ) then
			if (SpellAlertSCTDB[playerName].Emotes == true) then
				SpellAlertSCTDB[playerName].Emotes = false;
				SpellAlertSCT_print("감정 표현 경고를 사용하지 않습니다.");
			else
				SpellAlertSCTDB[playerName].Emotes = true;
				SpellAlertSCT_print("감정 표현 경고를 사용합니다.");
			end
		else
			if (params == "on") then
				SpellAlertSCTDB[playerName].Emotes = true;
				SpellAlertSCT_print("감정 표현 경고를 사용합니다.");
			else
				SpellAlertSCTDB[playerName].Emotes = false;
				SpellAlertSCT_print("감정 표현 경고를 사용하지 않습니다.");
			end
		end
		elseif ( command == "red" ) then
		if ( not params ) then
			SpellAlertSCT_print("0.0과 1.0 사이의 숫자를 선택해야 합니다.");
		else
			if ( tonumber(params) and tonumber(params) <= 1 and tonumber(params) >= 0) then
				SpellAlertSCTDB[playerName].red = tonumber(params);
				sasct_color.r = SpellAlertSCTDB[playerName].red;
				SpellAlertSCT_print("빨간색의 설정값은 "..SpellAlertSCTDB[playerName].red.." 입니다.");
				SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
			else
				SpellAlertSCT_print("0.0과 1.0 사이의 숫자를 선택해야 합니다.");
			end
		end
	elseif ( command == "green" ) then
		if ( not params ) then
			SpellAlertSCT_print("0.0과 1.0 사이의 숫자를 선택해야 합니다.");
		else
			if ( tonumber(params) and tonumber(params) <= 1 and tonumber(params) >= 0) then
				SpellAlertSCTDB[playerName].green = tonumber(params);
				sasct_color.g = SpellAlertSCTDB[playerName].green;
				SpellAlertSCT_print("녹색의 설정값은 "..SpellAlertSCTDB[playerName].green.." 입니다.");
				SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
			else
				SpellAlertSCT_print("0.0과 1.0 사이의 숫자를 선택해야 합니다.");
			end
		end
	elseif ( command == "blue" ) then
		if ( not params ) then
			SpellAlertSCT_print("0.0과 1.0 사이의 숫자를 선택해야 합니다.");
		else
			if ( tonumber(params) and tonumber(params) <= 1 and tonumber(params) >= 0) then
				SpellAlertSCTDB[playerName].blue = tonumber(params);
				sasct_color.b = SpellAlertSCTDB[playerName].blue;
				SpellAlertSCT_print("파란색의 설정값은 "..SpellAlertSCTDB[playerName].blue.." 입니다.");
				SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
			else
				SpellAlertSCT_print("0.0과 1.0 사이의 숫자를 선택해야 합니다.");
			end
		end
	elseif ( command == "status" ) then
		SpellAlertSCT_ShowStatus();
	elseif ( command == "reset" ) then
		SpellAlertSCT_ResetOptions();
		SpellAlertSCT_print("설정을 초기화 합니다.");
		SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
	elseif ( command == "test" ) then
		SpellAlertSCT_SCTDisplay(playerName.."님이 애드온을 테스트 합니다.");
	else
		SpellAlertSCT_ShowUsage();
	end
	
end